
/*
Lithobox2 is a program created to generate 3D printable lithophanes

copyright 2018 Jennifer Weiler
http://jenweiart.com
////////////////////////////////   */
class BoxButton {

  float x;
  float y;
  float wid;
  float hei;
  String text;
  String text_alternate;
  int textSize;

  color col;
  color hover_col;
  color text_col;
  color text_hover_col;

  Boolean pictureButton;
  PImage picture;

  Boolean clicked;

  BoxButton(float _x, float _y, float _w, float _h, String _t, int _ts, Boolean p) {
    x = _x;
    y = _y;
    wid = _w;
    hei = _h;
    text = _t;
    String[] list = split(text, '/');
    if(list.length > 1){
      text = list[0];
      text_alternate = list[1];
    }
    textSize = _ts;
    
    pictureButton = p;
    if(pictureButton){
      picture = loadImage(textSize+".png");
    }
    
    col = color(100, 100, 100);
    hover_col= color(200, 200, 200);
    text_col= color(200, 200, 200);
    text_hover_col= color(50, 50, 50);

    clicked = false;
  }

  Boolean mouseOver() {  
    if (mouseX > x && mouseX < x+wid && mouseY > y && mouseY < y+hei) {
      return true;
    } else {
      return false;
    }
  }

  void render(Boolean b) {
    stroke(color(107, 191, 236));
    
    String t = text;
    if(!b){ t = text_alternate; }
    
    if (!pictureButton) {
      textSize(textSize);
      if (mouseOver()) {
        fill(hover_col);
        rect(x, y, wid, hei);
        fill(text_hover_col);
        text(t, x+(wid/2), y+(textSize/2)+(hei/2));
      } else {
        fill(col);
        rect(x, y, wid, hei);
        fill(text_col);
        text(t, x+(wid/2), y+(textSize/2)+(hei/2));
      }
    }else{ // pictures
         if (mouseOver()) {
        fill(hover_col);
      } else {
        fill(col);
      }
      rect(x, y, wid, hei);
      image(picture, x, y, wid, hei);
    }
  }
}

///////////All Buttons

ArrayList<BoxButton> stepButtons_0 = new ArrayList<BoxButton>();
ArrayList<BoxButton> stepButtons_1 = new ArrayList<BoxButton>();
ArrayList<BoxButton> stepButtons_2 = new ArrayList<BoxButton>();
ArrayList<BoxButton> stepButtons_3 = new ArrayList<BoxButton>();
ArrayList<BoxButton> saveButtons = new ArrayList<BoxButton>();

void setupBoxButtons() {

  stepButtons_0.add(new BoxButton((width/2)-75, 400, 150, 75, "START", 16, false));


  stepButtons_1.add(new BoxButton(width-200, height-150, 150, 75, "CONTINUE", 16,  false));
  stepButtons_1.add(new BoxButton(40, height-130, 75, 75, "orb.png", 1,  true));
  stepButtons_1.add(new BoxButton(120, height-130, 75, 75, "cylinder.png", 2,  true));
  stepButtons_1.add(new BoxButton(200, height-130, 75, 75, "vase.png", 3,  true));
  stepButtons_1.add(new BoxButton(280, height-130, 75, 75, "blank", 4,  true));
  stepButtons_1.add(new BoxButton(360, height-130, 150, 75, "UPLOAD IMAGE", 16,  false));


  stepButtons_2.add(new BoxButton(width-200, height-150, 150, 75, "CONTINUE", 16,  false));
  stepButtons_2.add(new BoxButton(75, 100, 150, 66, "ADD OUTER IMAGE/RESET OUTER IMAGE", 12,  false));
  stepButtons_2.add(new BoxButton(75, 200, 150, 66, "ADD INNER IMAGE/RESET INNER IMAGE", 12, false));

  stepButtons_3.add(new BoxButton(width-200, height-150, 150, 75, "EXPORT", 16, false));
  
  saveButtons.add(new BoxButton((width/2)-160, 350, 120, 60, "CONTINUE", 16, false));
  saveButtons.add(new BoxButton((width/2)+40, 350, 120, 60, "EXIT", 16, false));
  
  step2ExampleSrcImg = loadImage("exampleSrc.png");
}


void set4thBox(){  // set image for 4th button based on previous image
  int border = 6;
  PImage tmp = drawnBoxSave.get();
  int newH = stepButtons_1.get(4).picture.height-(border*2);
  int newW = int( float(newH) * float(tmp.width) / float(tmp.height));
  tmp.resize(newW, newH);
  tmp.loadPixels();
  stepButtons_1.get(4).picture.loadPixels();
  for(int y=0; y<stepButtons_1.get(4).picture.height; y++){
    for(int x=0; x<stepButtons_1.get(4).picture.width; x++){
      int loc = (x) + (y+2)*stepButtons_1.get(4).picture.width;
      if(x>border&&x<newH && y>border&&y<newH){
         int srcLoc = 0;
         if(x>stepButtons_1.get(4).picture.width/2){
           srcLoc = (x-(stepButtons_1.get(4).picture.width/2)) + ((y-border)*tmp.width);
         }else{
           srcLoc = ((stepButtons_1.get(4).picture.width/2)-(x-border)) + ((y-border)*tmp.width);
         }
         
         if(red(tmp.pixels[srcLoc]) > 127){
           stepButtons_1.get(4).picture.pixels[loc] =  color(255,255);
         }else{
           stepButtons_1.get(4).picture.pixels[loc] =  color(255,0);
         }
         
      }
     // else{
       // stepButtons_1.get(4).picture.pixels[loc] =  color(255,0);
     // }
    }
  }
  stepButtons_1.get(4).picture.updatePixels();
}
