
/*
Lithobox2 is a program created to generate 3D printable lithophanes

copyright 2018 Jennifer Weiler
http://jenweiart.com
////////////////////////////////   */
void printSides(ArrayList<PVector> outerPts, ArrayList<PVector> innerPts, int[][] relief_outer, int[][] relief_inner, int sides) {

  /// outer to inner scaler
  float oi_scaler = float(outerPts.size())/float(innerPts.size());

  /// SIDES
  for (int t_y = 0; t_y < outerPts.size(); t_y++) {
    for (int t_x = 0; t_x < sides; t_x++) {

      int curnt = relief_outer[t_x][t_y];
      if (curnt != -1) {
        ////////////  //////////  //////////  //////////  //////////  //////////      
        ////////////  //////////  //////////  //////////  //////////  //////////
        int toLeft;

        if (t_x > 0) {
          toLeft = t_x-1;
        } else {
          toLeft = sides-1; // if wraps around
        }


        int toRight;

        if (t_x < sides-1) {
          toRight = t_x+1;
        } else {
          toRight = 0; // if wraps around
        }

        PVector u1 = new PVector(t_x, t_y);
        if (t_y < outerPts.size()-1) {




          if (relief_outer[toLeft][t_y+1] != -1) {
            /// diagonal down to left
            int diag = relief_outer[toLeft][t_y+1];
            PVector u2 = new PVector(toLeft, t_y+1);
            if (relief_outer[t_x][t_y+1] == -1) { // down
              findInner(relief_outer, relief_inner, oi_scaler, innerPts.size(), sides, u1, u2, curnt, diag, true);
            }
            if (relief_outer[toLeft][t_y] == -1) { // left
              findInner(relief_outer, relief_inner, oi_scaler, innerPts.size(), sides, u1, u2, curnt, diag, false);
            }
          }



          if (relief_outer[toRight][t_y+1] != -1) { 
            //// diagonal down to right
            int diag = relief_outer[toRight][t_y+1];
            PVector u2 = new PVector(toRight, t_y+1);
            if (relief_outer[t_x][t_y+1] == -1) { // down
              findInner(relief_outer, relief_inner, oi_scaler, innerPts.size(), sides, u1, u2, curnt, diag, false);
            }
            if (relief_outer[toRight][t_y] == -1) { // right
              findInner(relief_outer, relief_inner, oi_scaler, innerPts.size(), sides, u1, u2, curnt, diag, true);
            }
          }

          /// down (check if t_x = 0 or t_x == rows-1)
          if (relief_outer[t_x][t_y+1] != -1) {
            int down = relief_outer[t_x][t_y+1];
            PVector u2 = new PVector(t_x, t_y+1);

            if (relief_outer[toRight][t_y] == -1 && relief_outer[toRight][t_y+1] == -1) {
              findInner(relief_outer, relief_inner, oi_scaler, innerPts.size(), sides, u1, u2, curnt, down, true);
            } else if (relief_outer[toLeft][t_y] == -1 && relief_outer[toLeft][t_y+1] == -1) {
              findInner(relief_outer, relief_inner, oi_scaler, innerPts.size(), sides, u1, u2, curnt, down, false);
            }
          }
        }


        if ( relief_outer[toRight][t_y] != -1) { 
          int right = relief_outer[toRight][t_y];
          PVector u2 = new PVector(toRight, t_y);

          if (t_y!=0 && relief_outer[t_x][t_y-1] == -1 && relief_outer[toRight][t_y-1] == -1) {
            findInner(relief_outer, relief_inner, oi_scaler, innerPts.size(), sides, u1, u2, curnt, right, true);
          } else if (t_y < outerPts.size()-1 && relief_outer[t_x][t_y+1] == -1 && relief_outer[toRight][t_y+1] == -1) {
            findInner(relief_outer, relief_inner, oi_scaler, innerPts.size(), sides, u1, u2, curnt, right, false);
          }
        }


        ////////////  //////////  //////////  //////////  //////////  ////////// 
        ////////////  //////////  //////////  //////////  //////////  //////////**/
      }
    }
  }
}





void findInner(int[][] relief_outer, int[][] relief_inner, float oi_scaler, int innerY, int sides, PVector u1, PVector u2, int p1, int p2, boolean dir) {
  // just find point closest to u1

  /////////////////////////////////////////////
  float closest = u1.y / oi_scaler;
  int c = 0;
  //  round closest up if > .5, down if less than .5
  // to left
  int tl = int(u1.x)-1;
  if (tl < 0) { 
    tl = sides-1;
  }
  // to right
  int tr = int(u1.x)+1;
  if (tr >= sides) { 
    tr = 0;
  }

  if (closest - int(closest) > .5) {
    c = int(closest) +1;
    if (relief_inner[int(u1.x)][c] == -1) {
      while (relief_inner[int(u1.x)][c] == -1) { 
        c = c-1;
      }
    }
  } else {
    c = int(closest);
    if (relief_inner[int(u1.x)][c] == -1) {
      while (relief_inner[int(u1.x)][c] == -1) { 
        c = c+1;
      }
    }
  }

  // if none of the nearest are -1
  if (relief_inner[tl][c] != -1  && relief_inner[tr][c] != -1 &&
    (c==0 ||  relief_inner[int(u1.x)][c-1] != -1) &&
    (c==innerY-1 ||  relief_inner[int(u1.x)][c+1] != -1)  ) {

    ////// if c == 0, keep moving down until a hit
    if (c==0) {
      while (relief_inner[tl][c] != -1  && relief_inner[tr][c] != -1 &&
        (c==0 ||  relief_inner[int(u1.x)][c-1] != -1) &&
        relief_inner[int(u1.x)][c+1] != -1) {
        c++;
      }
    }

    /// if c == innerY -1, keep moving up until a hit
    else if (c==innerY-1) {
      while (relief_inner[tl][c] != -1  && relief_inner[tr][c] != -1 &&
        (c==0 ||  relief_inner[int(u1.x)][c-1] != -1) &&
        relief_inner[int(u1.x)][c-1] != -1) {
        c--;
      }
    }

    /// if c in the middle, test up and down until a hit
    else {
      boolean hitWallTop = false;
      boolean hitWallBottom = false;
      boolean found = false;
      int dist = 1;
      while (!found) {
        int _up = c-dist;
        if (_up < 0) {
          hitWallTop = true;
        }
        int _down = c+dist;
        if (_down > innerY-1) {
          hitWallBottom = true;
        }

        if (!hitWallTop &&
          relief_inner[tl][_up] != -1  && relief_inner[tr][_up] != -1 &&
          (_up-1 ==0 || relief_inner[tl][_up-1] != -1 )) {
          c = _up;
          found = true;
        } else if (!hitWallBottom &&
          relief_inner[tl][_down] != -1  && relief_inner[tr][_down] != -1 &&
          (_down ==innerY-1 || relief_inner[tl][_down+1] != -1 )) {
          c = _down;
          found = true;
        } else if (hitWallTop && hitWallBottom) { // if somehow you hit top and bottom, abort
          found = true;
        }
      }
    }
  }


  int p3 = relief_inner[int(u1.x)][c];


  if (dir) {
    output.println("f "+(p1)+" "+(p2)+" "+(p3));
  } else {
    output.println("f "+(p1)+" "+(p3)+" "+(p2));
  }
  //////////////////////////////////////////////
  int p4;
  if (u1.y == u2.y) { // if to the right, therefore knowing no height problem
    int toRight = int(u1.x)+1;
    int c2 = c;
    if (toRight >= sides) {  
      toRight = 0;
    }
    p4 = relief_inner[toRight][c2];
    if (dir) {
      while (p4==-1) {
        c2++;
        p4 = relief_inner[toRight][c2];
      }
      output.println("f "+(p2)+" "+(p4)+" "+(p3));
    } else {
      while (p4==-1) {
        c2--;
        p4 = relief_inner[toRight][c2];
      }
      output.println("f "+(p2)+" "+(p3)+" "+(p4));
    }
  }
  //////////////////////////////////////////////
  //////////////////////////////////////////////
  if (  oi_scaler*(c+1) <= u2.y+1.5) { // if close enough with down sclaer

    //////////////////////////////////////////////
    //////////////////////////////////////////////
    if (u1.x == u2.x && u1.y != u2.y) {  // if straight down
      int c2 = c+1;
      int t=0;

      //if(dir){t++;}
      //  else{t--;}

      int t2 = int(u1.x + t);

      if (t2 >= sides) { 
        t2=0;
      } else if (t2 <0) { 
        t2=sides-1;
      }

      p4 = relief_inner[t2][c2];

      while (p4 == -1) {
        if (dir) {  
          t--;
        } else { 
          t++;
        }
        t2 = int(u1.x + t);
        if (t2 >= sides) { 
          t2=0;
        } else if (t2 <0) { 
          t2=sides-1;
        }
        p4 = relief_inner[t2][c2];
      }

      if (dir) {  
        output.println("f "+(p2)+" "+(p4)+" "+(p3));
      } else {   
        output.println("f "+(p2)+" "+(p3)+" "+(p4));
      }
    }
    //////////////////////////////////////////////
    //////////////////////////////////////////////
    //// if diagonal down to the left
    if ( u1.y != u2.y && (u1.x-1 == u2.x || (u1.x ==0 &&  u2.x == (sides-1)))) {  
      int c2 = c+1;
      int t = 0;


      if (dir) {
     //   t++;
      } else {
      //  t--;
      }

      int t2 = int(u2.x + t);

     /* if (t2 >= sides) { 
        t2=0;
      } else if (t2 <0) { 
        t2=sides-1;
      }//*/

      p4 = relief_inner[t2][c2];

      while (p4 == -1) {
        if (dir) {  
          t--;
        } else { 
          t++;
        }
        t2 = int(u2.x + t);
        if (t2 >= sides) { 
          t2=0;
        } else if (t2 <0) { 
          t2=sides-1;
        }
        p4 = relief_inner[t2][c2];
      }//*/

      if (dir) {  
        output.println("f "+(p2)+" "+(p4)+" "+(p3));
      } else {   
        output.println("f "+(p2)+" "+(p3)+" "+(p4));
      }
    }//*/


    //////////////////////////////////////////////
    //////////////////////////////////////////////
    ///// if diagonal down to the right

    if ( u1.y != u2.y && (u1.x+1 == u2.x || (u1.x ==(sides-1) &&  u2.x == 0))) {  
      int c2 = c+1;
      int t=0;

     /* if (dir) {
     //   t++;
      } else {
      //  t--;
      }//*/

      int t2 = int(u2.x + t);

      if (t2 >= sides) { 
        t2=0;
      } else if (t2 <0) { 
        t2=sides-1;
      }

      p4 = relief_inner[t2][c2];


      while (p4 == -1) {
        if (dir) {  
          t--;
        } else { 
          t++;
        }
        t2 = int(u2.x + t);
        if (t2 >= sides) { 
          t2=0;
        } else if (t2 <0) { 
          t2=sides-1;
        }
        p4 = relief_inner[t2][c2];
      }//*/

      if (dir) {  
        output.println("f "+(p2)+" "+(p4)+" "+(p3));
        if (relief_outer[int(u1.x)][int(u2.y)] != -1) { // fill in empty top and bot
          output.println("f "+(p1)+" "+(relief_outer[int(u1.x)][int(u2.y)])+" "+(p2));
        }
        if (relief_inner[int(u1.x)][c2] != -1) { // fill in empty top and bot
          output.println("f "+(p4)+" "+(relief_inner[int(u1.x)][c2])+" "+(p3));
        }
      } else {   
        output.println("f "+(p2)+" "+(p3)+" "+(p4));
        if (relief_outer[int(u2.x)][int(u1.y)] != -1) { // fill in empty top and bot
          output.println("f "+(p1)+" "+(p2)+" "+(relief_outer[int(u2.x)][int(u1.y)]));
        }
        if (relief_inner[int(u2.x)][c] != -1) { // fill in empty top and bot
          output.println("f "+(p3)+" "+(relief_inner[int(u2.x)][c])+" "+(p4));
        }
      }

    }//*/


    //////////////////////////////////////////////
    //////////////////////////////////////////////
  }//*/
  //////////////////////////////////////////////
  //////////////////////////////////////////////
}
